/* 
So you took the time look look at this code ... good for you!!

this is what you get when you quickly add functionality 
but dont take the time to write quality code. I know ... and I am deeply sorry for this mess :-) 
I will rewrite this (probably to vanilla js, because jQuery ) before version 8
*/

jQuery(document).ready(function ($) {
  /* -----===== TAB NAVIGATION =====----- */
  $(".cwv-tab-bar li").click(function (event) {
    event.preventDefault();

    $(".cwv-tab-panel").hide();
    $($(this).data("tab")).show();

    $(".cwv-tab-bar .active").removeClass("active");
    $(this).addClass("active");
    if (window.matchMedia("only screen and (max-width: 760px)").matches) {
      $([document.documentElement, document.body]).animate(
        {
          scrollTop: $($(this).data("tab")).offset().top,
        },
        400
      );
    }
  });

  /* -----===== SHOW/HIDE HELP =====----- */
  $(".cwv-help").click(function (event) {
    event.preventDefault();
    $($(this).data("help")).slideToggle();
  });

  /* -----===== SAVE OPTIONS =====----- */
  $("#criticaloptions").submit(function () {
    var data = $("#criticaloptions").serialize() + "&action=wpcwv_save_options";

    jQuery.post(ajaxurl, data, function (response) {
      vwc_toast({
        title: "Settings saved",
        text: "&#10004; Your settings have been saved",
      });

      wp_cwv_get_critical_rules();
      wp_cwv_get_script_rules();
      wp_cwv_get_preloads();
    });

    return false;
  });

  /* -----===== SHOW/HIDE DEPENDS OPTIONS =====----- */

  var show_hide_options = function () {
    $("#criticaloptions [data-depends]").each(function () {
      var depend_name = $(this).data("depends");

      console.log(depend_name);
      var depend_value = $(
        '#criticaloptions [name="' + depend_name + '"]:checked'
      ).val();
      if (depend_value == 0) {
        $(this).addClass("hidden");
      } else {
        $(this).removeClass("hidden");
      }
    });
  };

  show_hide_options();

  $(".fetchnow").click(function () {
    $.post(ajaxurl, { action: "cwv_generate_critical" }, function (res) {
      vwc_toast({
        title: "Success",
        text: "&#10004; The Critical CSS has been fetched",
      });
    });
  });

  $("#criticaloptions").change(function (e) {
    show_hide_options();
  });

  /* -----===== CRITIICAL CSS RULES =====----- */
  //bubble criticalcssrules
  $("#criticalcssrules").on("click", ".deleterule", function () {
    $.post(
      ajaxurl,
      { action: "delete_critical_css_rule", id: $(this).data("id") },
      function (html) {
        wp_cwv_get_critical_rules();
      }
    );
    return false;
  });

  var wp_cwv_get_critical_rules = function () {
    $.post(
      ajaxurl,
      { action: "wp_cwv_get_critical_css_rules" },
      function (html) {
        $("#criticalcssrules").html(html);
      }
    );
  };

  wp_cwv_get_critical_rules();

  /* -----===== SCRIPT RULES =====----- */
  //bubble wp_cwv_delete_script_rule
  $("#scriptrules").on("click", ".deleterule", function () {
    $.post(
      ajaxurl,
      { action: "wp_cwv_delete_script_rule", id: $(this).data("id") },
      function (html) {
        wp_cwv_get_script_rules();
      }
    );
    return false;
  });

  // get rules
  var wp_cwv_get_script_rules = function () {
    $.post(ajaxurl, { action: "wp_cwv_get_script_rules" }, function (html) {
      $("#scriptrules").html(html);
    });
  };

  wp_cwv_get_script_rules();

  /* -----===== PRELOAD RULES =====----- */
  //bubble wp_cwv_delete_script_rule
  $("#preloads").on("click", ".deleterule", function () {
    $.post(
      ajaxurl,
      { action: "wp_cwv_delete_preload", id: $(this).data("id") },
      function (html) {
        wp_cwv_get_preloads();
      }
    );
    return false;
  });

  // get rules
  var wp_cwv_get_preloads = function () {
    $.post(ajaxurl, { action: "wp_cwv_get_preloads" }, function (html) {
      $("#preloads").html(html);
      $("#preloads select.preloadtype").change(function () {
        console.log($(this).val());
        // find parent tr
        var preloadfiletype = $(this)
          .closest("tr")
          .find("select.preloadfiletype");
        if ($(this).val() == "preload") {
          preloadfiletype.show();
        } else {
          preloadfiletype.hide();
        }
      });
    });
  };

  wp_cwv_get_preloads();

  /* -----===== CLEAR CACHES =====----- */
  $("#clearhtmlcache").click(function () {
    $.post(ajaxurl, { action: "critical_clear_cache" }, function (res) {
      vwc_toast({
        title: "Success",
        text: "&#10004; The HTML Cache has been cleared",
      });
    });
  });

  $("#clearcriticalcache").click(function () {
    $.post(ajaxurl, { action: "critical_clear_critical" }, function (res) {
      vwc_toast({
        title: "Success",
        text: "&#10004; The Critical CSS Cache has been cleared",
      });
    });
  });

  /* toast */
  var vwc_toast = function (obj) {
    $("#vwc_toast #toasttitle").html(obj.title);
    $("#vwc_toast #toasttext").html(obj.text);
    $("#vwc_toast").addClass("show");
    setTimeout(function () {
      $("#vwc_toast").removeClass("show");
    }, 5000);
  };

  /* -----===== DEBUG AN URL =====----- */
  $("#cwv_debug_button").click(function () {
    vwc_toast({ title: "Success", text: "&#10004; Debugging started" });
    $.post(
      ajaxurl,
      { action: "cwv_debug_url", url: $("#cwv_debug_url").val() },
      function (res) {
        var response = jQuery.parseJSON(res);
        $("#cwv_debug_data").text(response.res);
      }
    );
  });

  /* -----===== GET RUM DATA =====----- */

  $("#cwv_truncate_rum").click(function () {
    $.post(ajaxurl, { action: "cwv_truncate_rum" }, function (res) {
      vwc_toast({
        title: "Success",
        text: "&#10004; The RUM has been cleared, please reload this page",
      });
    });
  });

  $("#cwv_tmp_to_main").click(function () {
    $.post(ajaxurl, { action: "cwv_tmp_to_main" }, function (res) {
      vwc_toast({
        title: "Success",
        text: "&#10004; The RUM data will now be fetched and refreshed",
      });
      fetchRUM.init();
    });
  });

  const CWVMetrics = [
    {
      name: "CLS",
      fullname: "Cumulative Layout Shift",
      digits: 2,
      unit: "",
      rating: [0.1, 0.25],
    },
    {
      name: "FID",
      fullname: "First Input Delay",
      digits: 0,
      unit: "ms",
      rating: [100, 300],
    },
    {
      name: "INP",
      fullname: "Interaction to Next Paint",
      digits: 0,
      unit: "ms",
      rating: [200, 500],
    },
    {
      name: "TTFB",
      fullname: "Time To First Byte",
      digits: 0,
      unit: "ms",
      rating: [800, 1800],
    },
    {
      name: "FCP",
      fullname: "First Contentful Paint",
      digits: 0,
      unit: "ms",
      rating: [1800, 3000],
    },
    {
      name: "LCP",
      fullname: "Largest Contentful Paint",
      digits: 0,
      unit: "ms",
      rating: [2500, 4000],
    },
  ];

  const formatCWVMetric = (metric, p75) => {
    if (p75 > 1000 && metric.unit == "ms") {
      return (p75 / 1000).toFixed(1) + "s";
    }
    return (p75 * 1).toFixed(metric.digits) + metric.unit;
  };

  const getCWVClass = (metric, p75) => {
    if (p75 < metric.rating[0]) {
      return "good";
    }
    if (p75 < metric.rating[1]) {
      return "improve";
    }
    return "bad";
  };

  /* filter for the selectec device */
  const rumDevice = {
    device: "all",
    init: function () {
      $(".rum_device").click(function () {
        rumDevice.device = $(this).data("device");
        $(".rum_device").removeClass("active");
        $(this).addClass("active");
        fetchRUM.init();
        fetchURLS.showData();
      });
    },
  };

  rumDevice.init();

  var fetchURLS = {
    chosenmetric: 'all',

    /* -----===== SET Event Listeners =====----- */
    init: function () {
      $(".rum_metric").click(function () {
        $(".rum_metric").removeClass("active");
        $(this).addClass("active");
        fetchURLS.setMetric($(this).data("metric"));
        fetchURLS.showData();
      });
    },

    setMetric: function (metric) {
      fetchURLS.chosenmetric = metric;
    },
    
    showData: function () {
      if (fetchURLS.chosenmetric == "all") {
        $(".cwv-rum-card").show();
        $("#urllist").hide();
        $(".cwv-rum-grid").removeClass("metricview");

      } else {

        $(".cwv-rum-card").hide();
        $(".cwv-rum-grid").addClass("metricview");

        $(".cwv-rum-card#" + fetchURLS.chosenmetric).show();
        $("#urllist").show();
        $("#urllist").html("");

        const table = $("<table class=\"rumtable\">").appendTo("#urllist");
        const thead = $("<thead>").appendTo(table);
        const tbody = $("<tbody>").appendTo(table);

        let tr = $("<tr>").appendTo(thead);

        $("<th>").text("URL").appendTo(tr);
        $("<th width=\"40\">").text("P75").appendTo(tr);
        $("<th width=\"40\">").text("Visits").appendTo(tr);
        $("<th width=\"50\">").text("Score").appendTo(tr);

        $.post(
          ajaxurl,
          { action: "cwv_get_urllist", metric: fetchURLS.chosenmetric, d: rumDevice.device },
          function (urllist) {
            urllist = JSON.parse(urllist);

            for (const url in urllist) {
              if (urllist.hasOwnProperty(url)) {
                const data = urllist[url];
                let tr = $("<tr>").appendTo(tbody);

                let metricObj = CWVMetrics.find((o) => o.name === fetchURLS.chosenmetric);

                //find metric in CWVMetrics
                let metricClass = getCWVClass(metricObj, data.p75);

                $("<td>").html(`<a href="${data.u}">${data.u}</a>`).appendTo(tr);
                $("<td>").text(formatCWVMetric(metricObj, data.p75)).appendTo(tr);
                $("<td>").text(data.count).appendTo(tr);
                $("<td>").html(`<span class="badge ${metricClass}">${metricClass}</span>`).appendTo(tr);
                //$("<td>").text(metricClass).appendTo(tr);

              }
            }

            table.TableSorter();

          }
        );
      }
    }
  };



  // when clicked on a metric
  fetchURLS.init();

  const fetchRUM = {
    rum: {},
    init: function () {
      this.getCache();
    },
    getDivs: function () {
      CWVMetrics.forEach(function (metric) {
        fetchRUM.div = document.getElementById(metric.name);
        fetchRUM.div_home = document.getElementById("home" + metric.name);
      });
    },
    getCache: function () {
      $.post(
        ajaxurl,
        { action: "cwv_rum_cache", d: rumDevice.device },
        function (rum) {
          fetchRUM.rum = JSON.parse(rum);
          fetchRUM.getLiveData();
        }
      );
    },
    getLiveData: function () {
      CWVMetrics.forEach(function (metric) {
        let div_el = document.getElementById(metric.name);
        let homediv_el = document.getElementById("home" + metric.name);

        /* p75 data cached or get live? */
        if (fetchRUM.rum[metric.name] && fetchRUM.rum[metric.name].p75) {
          fetchRUM.renderP75(
            fetchRUM.rum[metric.name].p75,
            metric,
            div_el,
            homediv_el
          );
        } else {
          $.post(
            ajaxurl,
            { action: "cwv_get_p75", metric: metric.name, d: rumDevice.device },
            function (p75data) {
              p75data = JSON.parse(p75data);
              fetchRUM.renderP75(p75data.p75, metric, div_el, homediv_el);
            }
          );
        }

        // histogram
        let histogram_el = div_el.querySelector(".cwv-rum-histogram");
        if (fetchRUM.rum[metric.name] && fetchRUM.rum[metric.name].histogram) {
          ChartJSHistogram.init(
            histogram_el,
            fetchRUM.rum[metric.name].histogram,
            metric
          );
        } else {
          $.post(
            ajaxurl,
            {
              action: "cwv_get_histogram",
              metric: metric.name,
              d: rumDevice.device,
            },
            function (histogram) {
              histogram = JSON.parse(histogram);

              let histogram_el = div_el.querySelector(".cwv-rum-histogram");
              ChartJSHistogram.init(histogram_el, histogram, metric);
            }
          );
        }

        // timeline
        let timeline_el = div_el.querySelector(".cwv-rum-timeline");
        if (fetchRUM.rum[metric.name] && fetchRUM.rum[metric.name].timeline) {
          ChartJSTimeline.init(
            timeline_el,
            fetchRUM.rum[metric.name].timeline,
            metric
          );
        } else {
          $.post(
            ajaxurl,
            {
              action: "cwv_get_timeline",
              metric: metric.name,
              d: rumDevice.device,
            },
            function (timeline) {
              timeline = JSON.parse(timeline);
              ChartJSTimeline.init(timeline_el, timeline, metric);
            }
          );
        }

        // progress
        let progressbar_el = div_el.querySelector(".cwv-rum-progress");

        if (fetchRUM.rum[metric.name] && fetchRUM.rum[metric.name].progress) {
          progressbar_el.innerHTML = progressbartoscreen(
            fetchRUM.rum[metric.name].progress
          );
        } else {
          $.post(
            ajaxurl,
            {
              action: "cwv_get_progress",
              metric: metric.name,
              d: rumDevice.device,
            },
            function (progress) {
              progress = JSON.parse(progress);

              progressbar_el.innerHTML = progressbartoscreen(progress);
            }
          );
        }
      });
    },
    renderP75: function (p75data, metric, div_el, homediv_el) {
      div_el.classList.remove("good", "improve", "bad");
      div_el.classList.add(getCWVClass(metric, p75data));

      let p75_el = div_el.querySelector(".cwv-rum-value");
      p75_el.innerHTML = formatCWVMetric(metric, p75data);

      /* homepage buttons */
      homediv_el.classList.remove("good", "improve", "bad");
      homediv_el.classList.add(getCWVClass(metric, p75data));
      homediv_el.querySelector("#" + metric.name + "_value").innerHTML =
        formatCWVMetric(metric, p75data);
      homediv_el.querySelector("#" + metric.name + "_score .btn").innerHTML =
        getCWVClass(metric, p75data);
    },
  };

  fetchRUM.init();

  const ChartJSTimeline = {
    ctx: null,
    histogram: null,
    data: [],
    labels: [],
    LABEL2COLORS: { good: "#0fa859", improve: "#ffa400", bad: "#ff4e43" },

    init: function (ctx_parent_el, histogram, metric) {
      console.log("init", ctx_parent_el, histogram, metric);
      ctx_parent_el.innerHTML = "<canvas></canvas>";
      let ctx = ctx_parent_el.querySelector("canvas");

      ChartJSTimeline.ctx = ctx;
      ChartJSTimeline.histogram = histogram;
      ChartJSTimeline.metric = metric;

      this.formatData();
      this.formatLabels();
      this.ChartJSTimeline();
    },

    formatData: () => {
      ChartJSTimeline.data = ChartJSTimeline.histogram.map((el) => {
        //if (el.le) {
        return el.p75;
        //}
      });
    },

    formatLabels: () => {
      // loop through histogram and get labels

      ChartJSTimeline.labels = ChartJSTimeline.histogram.map((el) => {
        // if (el.le) {
        return el.date;
        //}
      });
    },

    ChartJSTimeline: function () {
      //@TODO: destroy old chart
      new Chart(this.ctx, {
        type: "line",
        data: {
          labels: ChartJSTimeline.labels,
          datasets: [
            {
              fill: true,
              lineTension: 0.3,
              borderColor: "#3B82F6",
              backgroundColor: "#518ef38f",

              borderWidth: 2,
              pointRadius: 2,
              pointHoverRadius: 5,
              borderCapStyle: "butt",
              pointHoverRadius: 5,
              pointHoverBackgroundColor: "rgba(59, 130, 246, 1)",
              pointHoverBorderColor: "rgba(59, 130, 246, 1)",
              pointHoverBorderWidth: 2,
              data: ChartJSTimeline.data,
            },
          ],
        },
        options: {
          responsive: true,
          maintainAspectRatio: false,
          plugins: {
            legend: {
              display: false,
            },
          },

          scales: {
            x: {
              type: "time",

              time: {
                unit: "day",
                tooltipFormat: "YYY-MM-dd",
              },
            },
            y: {
              beginAtZero: true,
            },
          },
        },
      });
    },
  };

  const ChartJSHistogram = {
    ctx: null,
    histogram: null,
    data: [],
    labels: [],
    LABEL2COLORS: { good: "#0fa859", improve: "#ffa400", bad: "#ff4e43" },

    init: function (ctx_parent_el, histogram, metric) {
      ctx_parent_el.innerHTML = "<canvas></canvas>";
      let ctx = ctx_parent_el.querySelector("canvas");

      ChartJSHistogram.ctx = ctx;
      ChartJSHistogram.histogram = histogram;
      ChartJSHistogram.metric = metric;

      this.normalizeData();
      this.formatData();
      this.formatLabels();
      this.formatColors();
      this.chartJsHistogram();
    },

    normalizeData: () => {
      ChartJSHistogram.histogram.newdata = [];
      for (let i = 0; i <= ChartJSHistogram.histogram.steps; i++) {
        let histogram = i * ChartJSHistogram.histogram.bucketstep;
        let expectedObj = ChartJSHistogram.histogram.rows.find(
          (o) => o.histogram == histogram
        ) || { histogram: histogram, Count: 0 };

        ChartJSHistogram.histogram.newdata.push(expectedObj);
      }
    },

    formatData: () => {
      ChartJSHistogram.data = ChartJSHistogram.histogram.newdata.map((el) => {
        //if (el.le) {
        return el.Count;
        //}
      });
    },

    formatLabels: () => {
      ChartJSHistogram.labels = ChartJSHistogram.histogram.newdata.map((el) => {
        // if (el.le) {
        return el.histogram;
        //}
      });
    },

    formatColors: () => {
      ChartJSHistogram.colors = ChartJSHistogram.histogram.newdata.map((el) => {
        let label = getCWVClass(ChartJSHistogram.metric, el.histogram);
        return ChartJSHistogram.LABEL2COLORS[label];
      });
    },

    chartJsHistogram: function () {
      //@TODO: destroy old chart
      new Chart(this.ctx, {
        type: "bar",
        data: {
          labels: ChartJSHistogram.labels,
          datasets: [
            {
              fill: true,
              data: ChartJSHistogram.data,
              borderColor: ChartJSHistogram.colors,
              backgroundColor: ChartJSHistogram.colors,
            },
          ],
        },
        options: {
          responsive: true,
          maintainAspectRatio: false,
          plugins: {
            legend: {
              display: false,
            },
          },
          scales: {
            x: {
              grid: {
                display: false,
              },
            },

            y: {
              grid: {
                color: "#f6f7fa",
              },
            },
          },
        },
      });
    },
  };

  const progressbartoscreen = function (progress) {
    // find in array of objects by name
    let good = progress.find((o) => o.progressbar === "good");
    let improve = progress.find((o) => o.progressbar === "improve");
    let bad = progress.find((o) => o.progressbar === "bad");

    good = good || { Count: 0 };
    improve = improve || { Count: 0 };
    bad = bad || { Count: 0 };

    let total = good.Count * 1 + improve.Count * 1 + bad.Count * 1;

    good.Width = (good.Count / total) * 100;
    improve.Width = (improve.Count / total) * 100;
    bad.Width = (bad.Count / total) * 100;

    return `
         <div class="cwv-good" style="width:${good.Width}%"></div>
         <div class="cwv-improve" style="width:${improve.Width}%"></div>
         <div class="cwv-bad" style="width:${bad.Width}%"></div>
        `;
  };
});


;(function ($, undefined) {

  var defaults = {
      arrows		: { up : '&#x25B4;', down : '&#x25BE;' },
  columns		: 'th',
  icon_class	: 'ts-sort-indicator'
  };

  function Plugin( element, options ) {
      this.element = $( element );
      this.options = $.extend( {}, defaults, options );
  this.isSorting = false;
      this.init();
  }

  Plugin.prototype.init = function () {
  var _self = this;
  this.element.find( this.options.columns ).on( 'click', function () {
    _self.onColumnClick.call( _self, this );
  });
  };

Plugin.prototype.onColumnClick = function ( element ) {
  var $this = $( element ), index = $this.index();
  
  this.removeSortIndicators();
  this.setSortingIcon( element );
  this.sortColumn( index );
};

Plugin.prototype.removeSortIndicators = function () {
  this.element.find( '.' + this.options.icon_class ).remove();
};

Plugin.prototype.setSortingIcon = function ( column ) {
  $('<span />')
    .addClass( this.options.icon_class )
    .html((this.isSorting != true) ? this.options.arrows.up : this.options.arrows.down )
    .appendTo( column );
  
  this.isSorting = !this.isSorting;
  
  return this;
};

Plugin.prototype.sortColumn = function ( index ) {
  var _self = this, $trs = this.element.find( 'tbody tr' );
  
  $trs.sort( function ( tr1, tr2 ) {
    var v1 = _self.getTDValueByIndex( tr1, index ),
        v2 = _self.getTDValueByIndex( tr2, index );
            
    return _self.compareValues.call( _self, v1, v2 );
  });
  
  this.element.find( 'tbody' ).empty().append( $trs );
  return this;
};

Plugin.prototype.compareValues = function ( v1, v2 ) {		
  if ( isNaN( v1 ) ) {
    if ( this.isSorting ) return v1.localeCompare( v2 );
    return v2.localeCompare( v1 );
  }
  else return this.sortNumbers( v1, v2 );
};

Plugin.prototype.sortNumbers = function ( v1, v2 ) {			
  var order  = ( v1 < v2 ) ? -1 : 0;
  
  if ( v1 > v2 ) order = 1;
  if ( this.isSorting && order !== 0 ) order = order * -1; 
  
  return order;
};

Plugin.prototype.getTDValueByIndex = function ( tr, index ) {
  var val = $.trim( $( tr ).find( 'td:eq( ' + index + ' )').text());
  return ( ! isNaN( val ) ) ? parseInt( val ) : val;
};

  $.fn.TableSorter = function ( options ) {
      return this.each(function () {
          if ( ! $.data( this, "plugin" ) ) {
              $.data( this, "plugin", new Plugin( this, options ) );
          }
      });
  };
})( jQuery );