<?php 

class cwv_imageavif extends cwv_converter implements cwv_converter_interface{

    public function convert(){
        if (function_exists('imageavif')) {

            switch ($this->origMimeType) {
                case 'image/jpeg':
                case 'image/jpg':
                    $image = imagecreatefromjpeg($this->aAbsPath['orig']);
                    break;

                case 'image/png':
                    $image = imagecreatefrompng($this->aAbsPath['orig']);
                    imagepalettetotruecolor($image);
                    imagealphablending($image, true);
                    imagesavealpha($image, true);
                    break;


                default:
                    return false;
            }

            // Save the image
            $result = imageavif($image, $this->aAbsPath['avif'], 80);

            if (false === $result) {
                return false;
            }

            // Free up memory
            imagedestroy($image);
            header('Converter: imageavif');
            return true;
        }

        return false;
    }

}