<?php class cwv_imagewebp extends cwv_converter implements cwv_converter_interface
{
    public function convert()
    {
        if (function_exists('imagewebp')) {

            switch ($this->origMimeType) {
                case 'image/jpeg':
                case 'image/jpg':
                    $image = imagecreatefromjpeg($this->aAbsPath['orig']);
                    break;

                case 'image/png':
                    $image = imagecreatefrompng($this->aAbsPath['orig']);
                    imagepalettetotruecolor($image);
                    imagealphablending($image, true);
                    imagesavealpha($image, true);
                    break;


                default:
                    return false;
            }


            // Save the image
            $result = imagewebp($image, $this->aAbsPath['webp'], 80);

            if (false === $result) {
                return false;
            }

            // Free up memory
            imagedestroy($image);
            header('Converter: imagewebp');
            return true;
        }

        return false;
    }
}
