<?php class cwv_imagick extends cwv_converter implements cwv_converter_interface
{
    public function convert()
    {
        if (class_exists('Imagick')) {
            $image = new Imagick();
            $image->readImage($this->aAbsPath['orig']);

            $image->setImageFormat('webp');
            $image->setImageCompressionQuality(80);
            $image->setImageAlphaChannel(0);
            $image->setBackgroundColor(new ImagickPixel('transparent'));

            $b = $image->writeImage($this->aAbsPath['webp']);
            if ($b === true) {
                header('Converter: Imagick');

                return true;
            }
        }

        return false;
    }
}
