<?php

namespace WPCWV;

if (!defined('ABSPATH')) {
    die('Let\'s not do this');
}

/* This is just all queries on one page for quick access, no abstration or anything :-) */

class AdvisorDB
{



    public static function createTable()
    {

        global $wpdb;
        $table_name_wp_cwv_files = $wpdb->prefix . 'cwv_advisor';

        $sql = "CREATE TABLE $table_name_wp_cwv_files (
			id mediumint(9) NOT NULL AUTO_INCREMENT,
			type varchar(255) NOT NULL,
			json TEXT DEFAULT '' NOT NULL,
			PRIMARY KEY  (id)
		);";

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);
    }


    public static function deleteOlder()
    {

        global $wpdb;
        $tabelname = $wpdb->prefix . 'cwv_advisor';
        $wpdb->query("DELETE FROM $tabelname WHERE id NOT IN ( 
                      SELECT id 
                      FROM ( 
                        SELECT id 
                        FROM $tabelname 
                        ORDER BY id DESC 
                        LIMIT 100
                      ) x 
                    );
                ");
    }


    public static function findTop()
    {
        global $wpdb;
        $rows = $wpdb->get_results('SELECT COUNT(*) as cnt, json  FROM ' . $wpdb->prefix . 'cwv_advisor GROUP BY json ORDER BY cnt DESC LIMIT 3;');
        return (is_array($rows)) ? $rows : [];
    }

    public static function findAll()
    {
        global $wpdb;
        $rows = $wpdb->get_results('SELECT * FROM ' . $wpdb->prefix . 'cwv_advisor');
        return (is_array($rows)) ? $rows : [];
    }



    public static function insert($data)
    {
        global $wpdb;
        $table = $wpdb->prefix . 'cwv_advisor';
        $format = ['%s', '%s'];
        return  $wpdb->insert($table, $data, $format);
    }
}
